package edu.cmu.qatar._15121.hw6;

public class KeyValueBinarySearchTree<KeyType extends Comparable<KeyType>, DataType> {
    private TreeNode root;

    /**
     * The constructor.
     */
    public KeyValueBinarySearchTree() {

    }

    /**
     * Add an item to the tree. You should determine the appropriate node to put the
     * item based on the key, and at the node store both the key and the data.
     * 
     * @param key  The key used for searching/finding the appropriate location for
     *             the item.
     * @param data The data to be stored at the location.
     * @exception IllegalStateException if attempting to add a key that is already
     *                                  in the tree. Use the same text within the
     *                                  exception that we used for our in-class
     *                                  example.
     */
    public void add(KeyType key, DataType data) {

    }

    /**
     * Determines and returns the size of the tree (total number of nodes).
     * 
     * @return The number of nodes in the tree.
     */
    public int size() {
        return 42;
    }

    /**
     * Determine whether or not the tree is empty.
     * 
     * @return true if the tree is empty, false otherwise.
     */
    public boolean isEmpty() {
        return true;
    }

    /**
     * Finds and returns the length of the longest path (number of edges) from the
     * root to a leaf. Recall that the height of a 1-node tree (just the root) is 0
     * (as is the height of an empty tree) and the height of a node is the length of
     * the longest path from that node to a leaf.
     * 
     * @return The height of the tree.
     */
    public int height() {
        return 42;
    }

    /**
     * Returns true if this tree is balanced, meaning that the height of the left
     * subtree and the height of the right subtree of each node (not just the root)
     * differ by no more than 1; returns false otherwise. An empty tree is
     * (trivially) balanced.
     * 
     * @return true if the tree is balanced and false otherwise.
     */
    public boolean isBalanced() {
        return false;
    }

    /**
     * Searches the tree for the node represented by key and returns the data stored
     * at the node.
     * 
     * @param key The key to search for in the tree
     * @return The data at the node represented by key, or null if the key is not
     *         found in the tree.
     */
    public DataType find(KeyType key) {
        return null;
    }

    /**
     * Returns a new BST that is a shallow clone of the original, i.e., contains
     * nodes with the same keys and data in exactly the same locations.
     * The original tree should not be modified.
     * 
     * @return A clone of the tree.
     */
    public KeyValueBinarySearchTree<KeyType, DataType> clone() {
        return null;
    }

    /**
     * Returns a new tree that is the mirror of the original, i.e., all the nodes
     * that were initially in the left subtree of a node in the original tree are
     * now in the right subtree of that node in the mirrorTree. Note that this
     * effectively "flips" the sort order of the BST since all the smaller nodes
     * (which were on the left) will now be on the right. So the mirrorTree will be
     * sorted in descending order (which you can test by doing an in-order traversal
     * of the mirrored tree). The original tree should not be modified.
     * 
     * @return A mirrored copy of the tree.
     */
    public KeyValueBinarySearchTree<KeyType, DataType> mirrorTree() {
        return null;
    }

    /**
     * The TreeNode class is a private inner class used (only) by this class
     */
    private class TreeNode {
        private KeyType key;
        private DataType data;
        private TreeNode left;
        private TreeNode right;

        private TreeNode(KeyType key, DataType data, TreeNode left, TreeNode right) {
            this.key = key;
            this.left = left;
            this.right = right;
            this.data = data;
        }
    }

    /**
     * returns a String that prints tree top to bottom, right to left in a 90-degree
     * rotated level view. Do note remove these toString methods, the autograder
     * will make use of them.
     */
    public String toString() {
        StringBuilder result = new StringBuilder();
        return toString(result, -1, root).toString();
    }

    private StringBuilder toString(StringBuilder res, int height, TreeNode rt) {
        if (rt != null) {
            height++;
            res = toString(res, height, rt.right);
            for (int i = 0; i < height; i++) {
                res.append("\t");
            }
            res.append(rt.key + "\n");
            res = toString(res, height, rt.left);
        }
        return res;
    }

    /**
     * A method to return the root of the tree. This is for the autograder, so don't
     * rename or remove this.
     * 
     * @return The root of the tree.
     */
    public TreeNode getRoot() {
        return this.root;
    }

    public static void main(String[] args) {
        // Your testcases go here.
    }

}
